<?php
/**
 * Point
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Logistic
 *
 * Управление логистикой
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\LogisticClient\Dto;

use \ArrayAccess;
use \Ensi\LogisticClient\ObjectSerializer;

/**
 * Point Class Doc Comment
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class Point implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Point';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'delivery_service' => 'int',
        'type' => 'int',
        'name' => 'string',
        'external_id' => 'string',
        'apiship_external_id' => 'string',
        'has_payment_card' => 'bool',
        'address' => '\Ensi\LogisticClient\Dto\Address',
        'city_guid' => 'string',
        'email' => 'string',
        'phone' => 'string',
        'timetable' => 'string',
        'active' => 'bool',
        'metro_stations' => '\Ensi\LogisticClient\Dto\MetroStation[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'delivery_service' => null,
        'type' => null,
        'name' => null,
        'external_id' => null,
        'apiship_external_id' => null,
        'has_payment_card' => null,
        'address' => null,
        'city_guid' => null,
        'email' => null,
        'phone' => null,
        'timetable' => null,
        'active' => null,
        'metro_stations' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'created_at' => false,
        'updated_at' => false,
        'delivery_service' => false,
        'type' => false,
        'name' => false,
        'external_id' => false,
        'apiship_external_id' => false,
        'has_payment_card' => false,
        'address' => false,
        'city_guid' => true,
        'email' => true,
        'phone' => true,
        'timetable' => true,
        'active' => false,
        'metro_stations' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'delivery_service' => 'delivery_service',
        'type' => 'type',
        'name' => 'name',
        'external_id' => 'external_id',
        'apiship_external_id' => 'apiship_external_id',
        'has_payment_card' => 'has_payment_card',
        'address' => 'address',
        'city_guid' => 'city_guid',
        'email' => 'email',
        'phone' => 'phone',
        'timetable' => 'timetable',
        'active' => 'active',
        'metro_stations' => 'metro_stations'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'delivery_service' => 'setDeliveryService',
        'type' => 'setType',
        'name' => 'setName',
        'external_id' => 'setExternalId',
        'apiship_external_id' => 'setApishipExternalId',
        'has_payment_card' => 'setHasPaymentCard',
        'address' => 'setAddress',
        'city_guid' => 'setCityGuid',
        'email' => 'setEmail',
        'phone' => 'setPhone',
        'timetable' => 'setTimetable',
        'active' => 'setActive',
        'metro_stations' => 'setMetroStations'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'delivery_service' => 'getDeliveryService',
        'type' => 'getType',
        'name' => 'getName',
        'external_id' => 'getExternalId',
        'apiship_external_id' => 'getApishipExternalId',
        'has_payment_card' => 'getHasPaymentCard',
        'address' => 'getAddress',
        'city_guid' => 'getCityGuid',
        'email' => 'getEmail',
        'phone' => 'getPhone',
        'timetable' => 'getTimetable',
        'active' => 'getActive',
        'metro_stations' => 'getMetroStations'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('delivery_service', $data, null);
        $this->setIfExists('type', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('external_id', $data, null);
        $this->setIfExists('apiship_external_id', $data, null);
        $this->setIfExists('has_payment_card', $data, null);
        $this->setIfExists('address', $data, null);
        $this->setIfExists('city_guid', $data, null);
        $this->setIfExists('email', $data, null);
        $this->setIfExists('phone', $data, null);
        $this->setIfExists('timetable', $data, null);
        $this->setIfExists('active', $data, null);
        $this->setIfExists('metro_stations', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id Идентификатор пункта
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime|null
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime|null $created_at Дата создания
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime|null
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime|null $updated_at Дата обновления
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets delivery_service
     *
     * @return int|null
     */
    public function getDeliveryService()
    {
        return $this->container['delivery_service'];
    }

    /**
     * Sets delivery_service
     *
     * @param int|null $delivery_service delivery_service
     *
     * @return $this
     */
    public function setDeliveryService($delivery_service)
    {


        /*if (is_null($delivery_service)) {
            throw new \InvalidArgumentException('non-nullable delivery_service cannot be null');
        }*/
        $this->container['delivery_service'] = $delivery_service;

        return $this;
    }

    /**
     * Gets type
     *
     * @return int|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param int|null $type type
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Название пункта
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets external_id
     *
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->container['external_id'];
    }

    /**
     * Sets external_id
     *
     * @param string|null $external_id Id пункта у службы доставки
     *
     * @return $this
     */
    public function setExternalId($external_id)
    {


        /*if (is_null($external_id)) {
            throw new \InvalidArgumentException('non-nullable external_id cannot be null');
        }*/
        $this->container['external_id'] = $external_id;

        return $this;
    }

    /**
     * Gets apiship_external_id
     *
     * @return string|null
     */
    public function getApishipExternalId()
    {
        return $this->container['apiship_external_id'];
    }

    /**
     * Sets apiship_external_id
     *
     * @param string|null $apiship_external_id Id пункта у ApiShip
     *
     * @return $this
     */
    public function setApishipExternalId($apiship_external_id)
    {


        /*if (is_null($apiship_external_id)) {
            throw new \InvalidArgumentException('non-nullable apiship_external_id cannot be null');
        }*/
        $this->container['apiship_external_id'] = $apiship_external_id;

        return $this;
    }

    /**
     * Gets has_payment_card
     *
     * @return bool|null
     */
    public function getHasPaymentCard()
    {
        return $this->container['has_payment_card'];
    }

    /**
     * Sets has_payment_card
     *
     * @param bool|null $has_payment_card Возможна ли оплата картой
     *
     * @return $this
     */
    public function setHasPaymentCard($has_payment_card)
    {


        /*if (is_null($has_payment_card)) {
            throw new \InvalidArgumentException('non-nullable has_payment_card cannot be null');
        }*/
        $this->container['has_payment_card'] = $has_payment_card;

        return $this;
    }

    /**
     * Gets address
     *
     * @return \Ensi\LogisticClient\Dto\Address|null
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param \Ensi\LogisticClient\Dto\Address|null $address address
     *
     * @return $this
     */
    public function setAddress($address)
    {


        /*if (is_null($address)) {
            throw new \InvalidArgumentException('non-nullable address cannot be null');
        }*/
        $this->container['address'] = $address;

        return $this;
    }

    /**
     * Gets city_guid
     *
     * @return string|null
     */
    public function getCityGuid()
    {
        return $this->container['city_guid'];
    }

    /**
     * Sets city_guid
     *
     * @param string|null $city_guid ФИАС id населенного пункта
     *
     * @return $this
     */
    public function setCityGuid($city_guid)
    {

        if (is_null($city_guid)) {
            array_push($this->openAPINullablesSetToNull, 'city_guid');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('city_guid', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['city_guid'] = $city_guid;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string|null
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string|null $email E-mail
     *
     * @return $this
     */
    public function setEmail($email)
    {

        if (is_null($email)) {
            array_push($this->openAPINullablesSetToNull, 'email');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('email', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets phone
     *
     * @return string|null
     */
    public function getPhone()
    {
        return $this->container['phone'];
    }

    /**
     * Sets phone
     *
     * @param string|null $phone Телефон
     *
     * @return $this
     */
    public function setPhone($phone)
    {

        if (is_null($phone)) {
            array_push($this->openAPINullablesSetToNull, 'phone');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('phone', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['phone'] = $phone;

        return $this;
    }

    /**
     * Gets timetable
     *
     * @return string|null
     */
    public function getTimetable()
    {
        return $this->container['timetable'];
    }

    /**
     * Sets timetable
     *
     * @param string|null $timetable График работы
     *
     * @return $this
     */
    public function setTimetable($timetable)
    {

        if (is_null($timetable)) {
            array_push($this->openAPINullablesSetToNull, 'timetable');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('timetable', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['timetable'] = $timetable;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active Активность
     *
     * @return $this
     */
    public function setActive($active)
    {


        /*if (is_null($active)) {
            throw new \InvalidArgumentException('non-nullable active cannot be null');
        }*/
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets metro_stations
     *
     * @return \Ensi\LogisticClient\Dto\MetroStation[]|null
     */
    public function getMetroStations()
    {
        return $this->container['metro_stations'];
    }

    /**
     * Sets metro_stations
     *
     * @param \Ensi\LogisticClient\Dto\MetroStation[]|null $metro_stations Станции метро
     *
     * @return $this
     */
    public function setMetroStations($metro_stations)
    {


        /*if (is_null($metro_stations)) {
            throw new \InvalidArgumentException('non-nullable metro_stations cannot be null');
        }*/
        $this->container['metro_stations'] = $metro_stations;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


